#include <stdio.h>
#include <string.h>

const long MAX_JUNCTIONS = 210;
const long INFINITY = 1000000000;
// typedef long TMatr[MAX_JUNCTIONS][MAX_JUNCTIONS];

long busy[MAX_JUNCTIONS];

long matr[MAX_JUNCTIONS][MAX_JUNCTIONS];

long n, r, q;


inline long Cube(long a)
{
	return a*a*a;
}

void Floyd()
{
	long i, j, k;
	for (k = 0; k < n; ++k)
		for (i = 0; i < n; ++i)
			for (j = 0; j < n; ++j)
				if (matr[i][j] > matr[i][k] + matr[k][j] && matr[i][k] < INFINITY && matr[k][j] < INFINITY)
					matr[i][j] = matr[i][k] + matr[k][j];
}

void FB()
{
	long i, j, k;
	for (k = 0; k < n; ++k)
		for (i = 0; i < n; ++i)
			for (j = 0; j < n; ++j)
				if (matr[0][j] > matr[0][i] + matr[i][j])
					matr[0][j] = matr[0][i] + matr[i][j];
}


int ExistNegativeCycle(long beg, long end)
{
	int enc = 0;
	long i;
	for (i = 0; i < n; ++i)
		if (matr[i][i] < 0  &&
			matr[beg][i] < INFINITY &&
			matr[i][end] < INFINITY)
		{
			enc = 1;
			break;
		}
	return enc;
}

int main()
{	
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	long iCase = 0;
	while (scanf("%ld", &n) == 1)
	{
		++iCase;
		long i, j, beg, end;

		for (i = 0; i < n; ++i)
			for (j = 0; j < n; ++j)
				if (i != j)
					matr[i][j] = INFINITY;
				else
					matr[i][j] = 0;


		for (i = 0; i < n; ++i)
			scanf("%ld", &busy[i]);

		scanf("%ld", &r);
		for (i = 0; i < r; ++i)
		{
			scanf("%ld %ld", &beg, &end);
			--beg;
			--end;
			matr[beg][end] = Cube(busy[end] - busy[beg]);
		}

		Floyd();


		scanf("%ld", &q);

		printf("Set #%ld\n", iCase);

		for (i = 0; i < q; ++i)
		{
			scanf("%ld", &end);
			--end;

			if (ExistNegativeCycle(0, end))
				puts("?");
			else
			{
				if (matr[0][end] >= 3 && matr[0][end] < INFINITY)
					printf("%ld\n", matr[0][end]);
				else
					puts("?");
			}
		}
	}

#ifndef ONLINE_JUDGE
	fclose(stdout);
	fclose(stdin);
#endif
	return 0;
}
